//+------------------------------------------------------------------+
//|                                             MTF_Stoch_Env_v1.mq4 |
//|                                                    2007, sashken |
//|                                                                  |
//+------------------------------------------------------------------+


#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 Gold
#property indicator_color4 Gold
#property indicator_color5 Blue

//---- input parameters
/*************************************************************************
PERIOD_M1   1
PERIOD_M5   5
PERIOD_M15  15
PERIOD_M30  30 
PERIOD_H1   60
PERIOD_H4   240
PERIOD_D1   1440
PERIOD_W1   10080
PERIOD_MN1  43200
You must use the numeric value of the timeframe that you want to use
when you set the TimeFrame' value with the indicator inputs.
---------------------------------------
PRICE_CLOSE    0 Close price. 
PRICE_OPEN     1 Open price. 
PRICE_HIGH     2 High price. 
PRICE_LOW      3 Low price. 
PRICE_MEDIAN   4 Median price, (high+low)/2. 
PRICE_TYPICAL  5 Typical price, (high+low+close)/3. 
PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
You must use the numeric value of the Applied Price that you want to use
when you set the 'applied_price' value with the indicator inputs.
**************************************************************************/
extern int     TimeFrame            = 0;     //   , 0-

extern int     Stochastic_Kperiod   = 6;
extern int     Stochastic_Dperiod   = 3;
extern int     Stochastic_Slowing   = 3;
extern int     Stochastic_PlusUP    = 0;     //   
extern int     Env_period           = 24;
extern int     Env_shift            = 1;
extern double  Env_deviation        = 28;

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
  {

//---- indicator line
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexStyle(2,DRAW_LINE,0,2);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexStyle(3,DRAW_LINE,0,2);
   SetIndexBuffer(4,ExtMapBuffer5);
   SetIndexStyle(4,DRAW_LINE);
   IndicatorDigits(4);

//---- name for DataWindow and indicator subwindow label
   switch(TimeFrame)
   {
      case 1 : string TimeFrameStr="Period_M1"; break;
      case 5 : TimeFrameStr="Period_M5"; break;
      case 15 : TimeFrameStr="Period_M15"; break;
      case 30 : TimeFrameStr="Period_M30"; break;
      case 60 : TimeFrameStr="Period_H1"; break;
      case 240 : TimeFrameStr="Period_H4"; break;
      case 1440 : TimeFrameStr="Period_D1"; break;
      case 10080 : TimeFrameStr="Period_W1"; break;
      case 43200 : TimeFrameStr="Period_MN1"; break;
      default : TimeFrameStr="Current Timeframe";
   }
   IndicatorShortName("MTF_Stoch_Env_v1("+Stochastic_Kperiod+", "+Env_period+", "+Env_deviation+") ("+TimeFrameStr+")");

  }
//----
   return(0);
 
//+------------------------------------------------------------------+
//|                                      |
//+------------------------------------------------------------------+
int start()
  {
   datetime TimeArray[];
   int    i,limit,y=0,counted_bars=IndicatorCounted();
 
// Plot defined time frame on to current time frame
   ArrayCopySeries(TimeArray,MODE_TIME,Symbol(),TimeFrame); 
   
   limit=Bars-counted_bars+TimeFrame/Period();
   for(i=0,y=0;i<limit;i++)
   {
   if (Time[i]<TimeArray[y]) y++;

/***********************************************************   
   Add your main indicator loop below.  You can reference an existing
      indicator with its iName  or iCustom.
   Rule 1:  Add extern inputs above for all neccesary values   
   Rule 2:  Use 'TimeFrame' for the indicator time frame
   Rule 3:  Use 'y' for your indicator's shift value
 **********************************************************/  
 
   ExtMapBuffer1[i] = iStochastic(NULL, 0, Stochastic_Kperiod, Stochastic_Dperiod, Stochastic_Slowing,MODE_SMA,0,MODE_MAIN, y)+Stochastic_PlusUP;
   ExtMapBuffer2[i] = iStochastic(NULL, 0, Stochastic_Kperiod, Stochastic_Dperiod, Stochastic_Slowing,MODE_SMA,0,MODE_SIGNAL, y)+Stochastic_PlusUP;
   }  
   
   for(i=0,y=0;i<limit;i++)
   {
   ExtMapBuffer3[i] = iEnvelopesOnArray(ExtMapBuffer1,0,Env_period,0,Env_shift,Env_deviation,MODE_LOWER,i);
   ExtMapBuffer4[i] = iEnvelopesOnArray(ExtMapBuffer1,0,Env_period,0,Env_shift,Env_deviation,MODE_UPPER,i);
   ExtMapBuffer5[i] = (iEnvelopesOnArray(ExtMapBuffer1,0,Env_period,0,Env_shift,Env_deviation,MODE_UPPER,i)+iEnvelopesOnArray(ExtMapBuffer1,0,Env_period,0,Env_shift,Env_deviation,MODE_LOWER,i))/2;
   }   

   return(0);
  }
//+------------------------------------------------------------------+